-- name: gm_construct.bsp (hangout)
-- description: physgun mod when \n\ \n\Thanks to @flipflopbell for the skybox template!

E_MODEL_CONSTRUCTSKYBOX2D = smlua_model_util_get_id("constructskybox_geo")
E_MODEL_CONSTRUCTSKYBOX3D = smlua_model_util_get_id("constructskybox3d_geo")
LEVEL_HANGOUT_CONSTRUCT = level_register('level_construct_entry', COURSE_NONE, 'gm_construct.bsp', 'construct', 28000, 0x00, 0x28, 0x28)

--SKYBOX TIME! (2d skybox code stolen from @flipflopbell on the ex-coop discord)

local l = gLakituState

function bhv_construct2dskybox_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
    obj_scale(o, 91.0)
end

function bhv_construct2dskybox_loop(o)
    o.oPosX = l.pos.x
    o.oPosY = l.pos.y
    o.oPosZ = l.pos.z
end

id_bhvConstruct2DSkybox = hook_behavior(bhvConstruct2DSkybox, OBJ_LIST_LEVEL, false, bhv_construct2dskybox_init, bhv_construct2dskybox_loop)

function SpawnSkybox()
    local skyboxcheck = obj_get_nearest_object_with_behavior_id(o, id_bhvConstruct2DSkybox)
    local p = gNetworkPlayers[0]
    if p.currLevelNum == LEVEL_HANGOUT_CONSTRUCT then
    set_override_far(400000)
    end
    if skyboxcheck == nil and p.currLevelNum == LEVEL_HANGOUT_CONSTRUCT then
        spawn_non_sync_object(id_bhvConstruct2DSkybox, E_MODEL_CONSTRUCTSKYBOX2D, l.pos.x, l.pos.y, l.pos.z, nil)
    end
end


function bhv_construct3dskybox_init(o)
    o.header.gfx.skipInViewCheck = true
    obj_scale(o, 38.0)   --38 for normal, XXX for dm
end

function bhv_construct3dskybox_loop(o)
    return
end

id_bhvConstruct3DSkybox = hook_behavior(bhvConstruct3DSkybox, OBJ_LIST_LEVEL, false, bhv_construct3dskybox_init, bhv_construct3dskybox_loop)

--LEVEL WARP TIME

function construct_tp()
    if gNetworkPlayers[0] then
        warp_to_level(LEVEL_HANGOUT_CONSTRUCT, 1, 0)
        return true
    end
end

hook_event(HOOK_ON_LEVEL_INIT, SpawnSkybox)
hook_chat_command("construct", "Loads gm_construct.bsp", construct_tp)